RD API Utilities
=======================================

This package provides common utilities used for Resource Description API and other associated SW such as CapabilityQueryLibrary.
Relates to EU Hz-2020 project ReCaM <http://www.recam-project.eu/>.

Repository location
--------------------
The main storage for this GIT repository can be found from:
<https://bitbucket.org/nikkeSi/rd_api>

Administrator of this GIT repository is:  
Tampere University (TAU) / 
Faculty of Engineering and Natural Sciences (ENS) / 
Automation Technology and Mechanical Engineering (ATME) / Manufacturing and Production Automation /  
Niko Siltala  
niko.siltala@tuni.fi
+358-40-536 6017  

Latest compiled packages can be found from the Maven repository:
<http://resourcedescription.tut.fi/maven/fi/tut/mei/resdescapi/RD_API/>

Authors
-------
The main authors for this repository are:

* Niko Siltala, niko.siltala@tuni.fi


Prerequisites
---------------

### Softwares to be installed:

Software Versions used for the application. If specific folder location is required, it is listed here. Any other additional information that applies.

See required software and versions from root project.

Compilation:
------------
Application will be compiled, deployed, etc. with Maven.  
Make sure Maven version is correct and that Maven uses right java version.
```shell
mvn -v		-> Checks which version of Maven is in use
java -version	-> Java version used
```

Other Maven targets and actions:
```shell
mvn compile			-> Compiles project
mvn test			-> Compile and run Unit tests
mvn package			-> Compiles, tests and makes jar package
mvn compile assembly:single	-> Compiles and makes jar package, which includes all dependency jar packages.
mvn exec:java			-> executes the RD API console application
mvn javadoc:javadoc		-> java doc generation
mvn install			-> Compiles, tests and makes jar package which is then copied to local maven repository
mvn clean			-> Cleans project folders from compiled files
```

The pom.xml file should be modified if the resources are located some other directory than given in Prerequisites.


FOLDER STRUCTURE:
-----------------

The folder structure follows standard Maven folder structures.

Folder | Description 
--- | ---
src/main/java/			| Java source codes
src/main/resources/		| Resource files
src/test/java/			| Test files
src/test/resources/			| Additional resources files for tests
target/				| compiled targets
doc/				| Documentation files. Mainly the java code documentation.

